/* Part of the SUDK sudoku puzzle solver/editor */
/* By Alex Wilson, copyright 2006 */

/* Solving algorithm based in part on the freeware work of
   Wim Colgate */

#ifndef _SOLVING_H
#define _SOLVING_H

#include <tigcclib.h>
#include "sudoku.h"

#define ROW_SIZE	9
#define SQUARE_X	3
#define SQUARE_Y	3
#define ARRAY_SIZE	81

#define BASE(n)		(((n)/ROW_SIZE)*ROW_SIZE)
#define TOP(n)		(((n)%ROW_SIZE))
#define ULEFT(n)	((BASE(n)/(ROW_SIZE*SQUARE_Y)*(ROW_SIZE*SQUARE_Y))+((((n)-BASE(n))/SQUARE_X)*SQUARE_X))

sudoku *solution;
HANDLE sol_handle;
int kill_search;

int place_next(int loc, sudoku *pboard);
int row_check(int loc, int val, sudoku *pboard);
int column_check(int loc, int val, sudoku *pboard);
int square_check(int loc, int val, sudoku *pboard);
int sudo(int loc, int num, sudoku *board);
int solve(sudoku *board);

#endif
